from moonLib import *
from JGCalendar import *
from Gengo4 import *
from monthTabLib3 import *
from Genka import *
from Giho import *

#■新暦に対応する旧暦を求める
def calcTempo(tm0):
    TIME=JDToWorld(tm0)  # ユリウス日をグレゴリオ暦に変換
    oldDate=[0,0,0,0]
    oldDate[0]=TIME[0]; oldDate[2]=TIME[1]; oldDate[3]=TIME[2]
    chu=[]  #①　中気計算用リスト
    chu.append(SWsolstice(tm0)) #計算対象の直前(最初)の二分二至の時刻(朔により後で補正)
    for i in range(1,4):        #中気の時刻を計算(4回分用意する）
        chu.append(calcChuki(chu[i-1][0]+32.0)) #chu[i,0]:中気の時刻  chu[i,1]:太陽黄経
    saku=[] #②
    saku.append(calcSaku(chu[0][0])) #計算対象の直前にあたる二分二至の直前の朔の時刻
    for i in range(1,5):             #朔の時刻を求める
        tm=saku[i-1]; tm+=30.01900
        saku.append(calcSaku(tm)) #前回計算した値との差が26日以内のとき35日を加算
        if abs(int(saku[i-1])-int(saku[i]))<= 26.0: #して，計算しなおし。
            saku[i]=calcSaku(saku[i-1]+35.0);
    if int(saku[1]) <= int(chu[0][0]):  #saku[1]が二分二至の時刻以前のとき
        for i in range(4):              #朔の時刻を繰り下げて修正
            saku[i]=saku[i+1]           #最後の朔時刻を再計算
        saku[4]=calcSaku(saku[3]+35.0)
    elif int(saku[0]) > int(chu[0][0]): #saku[0]が二分二至の時刻以後のとき
        for i in (4,3,2,1):             #朔の時刻を繰り上げて修正
            saku[i]=saku[i-1]           #先頭の朔時刻を再計算
        saku[0]=calcSaku(saku[0]-27.0)
        
    lap=0 #③ 節月の4ヶ月間に朔が5回あると閏月の可能性あり。
    if int(saku[4]) <= int(chu[3][0]): lap=1
    m=[[0 for i in range(3)] for j in range(5)] #④ 朔日行列の作成
    m[0][0]=int(chu[0][1]/30.0) + 2             # m[i,0] ： 月名（1:正月 2:２月 3:３月 ....）
    m[0][2]=int(saku[0])                        # m[i,2] ： 朔日のjd
    m[0][1]=0                                   # m[i,1] ： うるうフラグ（0:平月 1:うるう月）
    for i in range(1,5):
        if lap==1 and i!=1:                     #うるう月の判定
            if ((int(chu[i-1][0]) <= int(saku[i-1])) or
                (int(chu[i-1][0]) >= int(saku[i]))):
                m[i-1][0]=m[i-2][0]; m[i-1][1]=1
                m[i-1][2]=int(saku[i-1]);lap=0  #うるう月が連続することはない
        m[i][0]=m[i-1][0]+1
        if( m[i][0] > 12 ): m[i][0]-=12
        m[i][2]=int(saku[i])
        m[i][1]=0
    state=0 #⑤ 朔日行列から旧暦を求める
    for i in range(5): #(注)このとき，ループ完了のときPYTHONではi=4
        if int(tm0) < int(m[i][2]): 
            state=1         #日付がi番目の朔より小さければ,朔の前月
            break
        elif int(tm0) == int(m[i][2]):
            state=2         #日付がi番目の朔と同じであれば朔と同じ月(1日)
            break
    #朔日行列の最後より日付が大きい場合、最後の朔日と同じ月
    if state==1:i -= 1 
    oldDate[1]=m[i][1]; oldDate[2]=m[i][0] #うるう月フラグと月名は朔日行列の内容
    oldDate[3]=int(tm0)-int(m[i][2])+1 #⑥ 朔日を１日として日付を設定
    TIME=JDToWorld(tm0);oldDate[0]=TIME[0]
    #⑦ 旧暦月が10以上でかつ新暦月より大きい場合, 新暦年の前年とみなす。
    if oldDate[2] > 9 and oldDate[2] > TIME[1]: oldDate[0]-=1  
    return oldDate
#■新暦→旧暦のメイン関数(oldDate[]に結果が戻る)
def getTempo(Y, M, D):
    oldDate=getMonthTB([Y,M,D])
    if oldDate!=[]: return oldDate;
    if (YMD[0]<454 or (YMD[0]==454 and YMD[1]<12) or
        (YMD[0]==454 and YMD[1]==12 and YMD[2]<14)):
        return getGiho(YMD) #雄略天皇前は儀鳳暦（平朔）
    if YMD[0]<702: return getGenka(YMD) #大宝前は元嘉暦
  
    
    tm=WorldToJD(Y,M,D,0,0,0)
    return calcTempo(tm)
#■旧暦データの文字列への変換
def genOldDate(Dt):
    Leap=["","閏"]
    return "旧暦 %d/%s%d/%d" % (Dt[0],Leap[Dt[1]],Dt[2],Dt[3])
#■六曜の文字列設定
def rokuyo(M,D):
    ROKUYO=("先勝", "友引", "先負", "仏滅", "大安", "赤口")
    return ROKUYO[(M+D-2)%6]
#■カレンダ用文字列設定
def charCalender(Dt, flag):
    if Dt[1]==0 and Dt[2]==1 and Dt[3]==1:
        return "旧正月元旦"
    if flag:
        if Dt[1]: return "旧閏%d月%d日"%(Dt[2],Dt[3])
        return "旧%d月%d日"%(Dt[2],Dt[3])
    return "旧%d日"% Dt[3]


#■テスト用関数
def testOldDateforCalender():
    print("新暦の西暦年/月/日を数字以外の文字で区切って入力して下さい。")
    print("終るときは[Enter]のみを入力して下さい。")
    while 1:
        A=inputYMD()
        if A==[0]:
            break
        if len(A)!=3:
            print("年/月/日を入力して下さい")
        else:
            Dt=getTempo(A[0],A[1],A[2])
            C1=charCalender(Dt,True)
            C2=charCalender(Dt,False)
           
            R=rokuyo(Dt[2],Dt[3])
            print(genOldDate(Dt),R, C1, C2)
#testOldDateforCalender()

